SystemOrganization addCategory: #'MC2-Installer-Base'!

Object subclass: #MDInstaller
	instanceVariableNames: 'hasMonticello'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-Installer-Base'!

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:09'!
doInstall
	self hasMonticello
        ifTrue: [self installViaMC]
        ifFalse: [self installViaMczInstaller]
! !

!MDInstaller methodsFor: 'configuration' stamp: 'cwp 5/3/2006 00:16'!
files
	^ #(

	'SystemEditor-cwp.49.mcz'
	'Monticello2-avi.147.mcz'
	'MC2-Squeak-cwp.15.mcz'  
	
	)
! !

!MDInstaller methodsFor: 'preparation' stamp: 'cwp 5/3/2006 00:06'!
fixDependencyBug
	MczInstaller compile: 'versions: aVersionList anySatisfy: aDependencyID
	^ aVersionList anySatisfy: [:version | 
			aDependencyID = (version at: #id)
				or: [self 
						versions: (version at: #ancestors ifAbsent: [^ false]) 
						anySatisfy: aDependencyID]]
'
! !

!MDInstaller methodsFor: 'testing' stamp: 'cwp 5/3/2006 00:06'!
hasMonticello
	^ Smalltalk hasClassNamed: 'MCReader'
! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:06'!
install
	self shouldInstall ifTrue: [self doInstall]! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:06'!
installMC
	(SMSqueakMap default packageWithName: 'Monticello') releases last install! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:06'!
installViaMC
	 | repository versions addRepository |
	versions := OrderedCollection new.
	repository := self repository.
	addRepository := [:v | v workingCopy repositoryGroup addRepository: repository].
	MCRepositoryGroup default addRepository: repository.
	self files do: 
		[:filename | | version |
		version := repository loadVersionFromFileNamed: filename.
		versions add: version.
		version 
			load;
			in: addRepository.
		versions do: [:ea | ea workingCopy modified: false]]
        ! !

!MDInstaller methodsFor: 'installing' stamp: 'cwp 5/3/2006 00:06'!
installViaMczInstaller
	self fixDependencyBug.
	self files do: [:filename | | contents |
		contents := HTTPSocket httpGet: self repositoryUrl, filename.
		MczInstaller installStream: contents readStream.
	]
	  ! !

!MDInstaller methodsFor: 'testing' stamp: 'cwp 5/3/2006 00:19'!
noPreviousVersion
	^ (Smalltalk hasClassNamed: 'MDVersion') not! !

!MDInstaller methodsFor: 'preparation' stamp: 'cwp 5/3/2006 00:08'!
offerToInstallMC
	| ok |
	ok := self confirm: 'To upgrade from the installed version,
you must have Monticello installed. Would you like to install it now?'.
	ok ifTrue: [self installMC].
	^ ok! !

!MDInstaller methodsFor: 'accessing' stamp: 'cwp 5/3/2006 00:06'!
repository
	^ MCHttpRepository 
		location: self repositoryUrl 
		user: ''
		password: ''! !

!MDInstaller methodsFor: 'configuration' stamp: 'cwp 5/3/2006 00:10'!
repositoryUrl
	^ 'http://source.smallthought.com/mc'! !

!MDInstaller methodsFor: 'testing' stamp: 'cwp 5/3/2006 00:06'!
shouldInstall
	^ self noPreviousVersion 
		or: [self hasMonticello]
		or: [self offerToInstallMC]! !

!MDInstaller methodsFor: 'accessing' stamp: 'cwp 5/3/2006 00:06'!
versionName
	^ self files last! !
